(* Ambiente *)


let emptyenv = []; (* the empty environment *)

let rec lookup env x =
    match env with 
    | []        -> failwith (" not found")
    | (y, v)::r -> if x=y then v else lookup r x;;

(*Sintassi Astratta*)

type expr = 
  | CstI of int
  | Var of string
  | Let of string * expr * expr
  | Prim of string * expr * expr

(* Interprete *)

let rec eval (e : expr) (env : (string * int) list) : int =
    match e with
      | CstI i -> i
      | Var x  -> lookup env x 
      | Let(x, erhs, ebody) -> 
            let xval = eval erhs env 
            let env1 = (x, xval) :: env in
            eval ebody env1
      | Prim("+", e1, e2) -> eval e1 env + eval e2 env
      | Prim("*", e1, e2) -> eval e1 env * eval e2 env
      | Prim("-", e1, e2) -> eval e1 env - eval e2 env
      | Prim _            -> raise (Failure "unknown primitive") ;;

let run e = eval e []

